INTERVAL = 1.6

local ghostframe = CreateFrame('Frame')
local nexttick = GetTime()+INTERVAL
local enabled = false
local current = "herbalism"
local x = 0
local y = 0
local last_movement = 0
ghostframe:RegisterEvent("UI_ERROR_MESSAGE")
ghostframe:RegisterEvent("PLAYER_UNGHOST")
ghostframe:RegisterEvent("PLAYER_ALIVE")

local findMineralsSpellName = GetSpellInfo(2580)--'Mineraliensuche'
local findHerbsSpellName = GetSpellInfo(2383)--'Kräutersuche'

ghostframe:SetScript("OnUpdate", function()
	if not enabled or IsResting() then return end
	if SpellIsTargeting() then 
		nexttick = GetTime()+2.7
		return 
	end
	local cursorItem = GetCursorInfo()
	if cursorItem then return end
	local inCombat = InCombatLockdown() or UnitAffectingCombat("player")
	
	local current_time = GetTime()
	
	if (not inCombat or IsMounted()) and IsUsableSpell(findMineralsSpellName) and IsUsableSpell(findHerbsSpellName) then
		local mapID = C_Map.GetBestMapForUnit("player");
		if mapID then
			obj = C_Map.GetPlayerMapPosition(C_Map.GetBestMapForUnit("player"),"player");
		end
		
		local newx, newy
		if obj and obj.GetXY then
			newx, newy = obj:GetXY();
		end
		if not (newx == x and newy == y) then
			x = newx
			y = newy
			last_movement = current_time
			if current_time >= nexttick then
				if current == "herbalism" then
					CastSpellByName(findMineralsSpellName)
					current = "mining"
				else
					CastSpellByName(findHerbsSpellName)
					current = "herbalism"
				end
				nexttick = current_time+INTERVAL
			end
		else
			if last_movement + 0.4 < current_time then
				nexttick = current_time+1.25
			end
		end
	else
		if last_movement + 0.4 < current_time then
			nexttick = current_time+1.25
		end
	end
end)

local cancel_list = {
[ERR_NO_ATTACK_TARGET] = true,
[ERR_SPELL_COOLDOWN] = true,
[ERR_ABILITY_COOLDOWN] = true,
[ERR_GENERIC_NO_TARGET] = true,
[ERR_OUT_OF_RAGE] = true,
[ERR_BADATTACKFACING] = true,
[SPELL_FAILED_LINE_OF_SIGHT] = true,
[ERR_USE_TOO_FAR] = true,
[SPELL_FAILED_NOPATH] = true,
[SPELL_FAILED_MOVING] = true,
[ERR_BADATTACKPOS] = true,
[ERR_OUT_OF_RANGE] = true,
[SPELL_FAILED_NOT_BEHIND] = true,
}

ghostframe:HookScript("OnEvent", function (a,b,c,d)
	if not enabled or IsResting() then return end
	
	if cancel_list[d] then
		nexttick = GetTime()+2.7
	elseif b ~= "UI_ERROR_MESSAGE" then
		local miningUsable = IsUsableSpell(findMineralsSpellName);
		local herbalismUsable = IsUsableSpell(findHerbsSpellName);
	
		if (miningUsable) then
			CastSpellByName(findMineralsSpellName);
		elseif (herbalismUsable) then
			CastSpellByName(findHerbsSpellName);
		end
	end
end)


TrackingCycler = LibStub("AceAddon-3.0"):NewAddon("TrackingCycler", "AceEvent-3.0")
local TrackingCycler, self = TrackingCycler, TrackingCycler
local LDB = LibStub:GetLibrary("LibDataBroker-1.1")
local L = LibStub("AceLocale-3.0"):GetLocale("TrackingCycler")
local icon = LibStub("LibDBIcon-1.0")

-- LDB data object
local dataobj = LDB:NewDataObject("TrackingCycler", {
    type = "data source",
    text = '',
    icon = "Interface\\AddOns\\TrackingCycler\\icon.tga",
})

--  Local functions and tables
local _G = _G
local select = select
local CloseAllBags = CloseAllBags
local GetAddOnMetadata = GetAddOnMetadata
local GetBagName = GetBagName
local GetContainerNumFreeSlots = GetContainerNumFreeSlots
local GetContainerNumSlots = GetContainerNumSlots
local GetItemInfo = GetItemInfo
local GetItemInfoInstant = GetItemInfoInstant
local GetItemQualityColor = GetItemQualityColor
local IsShiftKeyDown = IsShiftKeyDown
local OpenAllBags = OpenAllBags
local ToggleBackpack = ToggleBackpack

-- Addon Metadata
local ADDON_TITLE = GetAddOnMetadata("TrackingCycler", "Title")
local ADDON_NOTES = GetAddOnMetadata("TrackingCycler", "Notes")


-- Shown on LDB dataobj mouseover.
function dataobj:OnTooltipShow()
    -- Title, grab it from the TOC.
    self:AddLine(ADDON_TITLE)

    self:AddLine("|cffffff00" .. L["Click|r to toggle cycling"])
end

function dataobj:OnClick(button)
    if button == "LeftButton" then
        if not ContainerFrame1:IsShown() then
			if enabled == false then
				enabled = true
				dataobj.icon = "Interface\\AddOns\\TrackingCycler\\icon2.tga"
			else
				enabled = false
				dataobj.icon = "Interface\\AddOns\\TrackingCycler\\icon.tga"
			end

		end
    end
end

function TrackingCycler:OnInitialize()
    --icon:Register("TrackingCycler", dataobj, db.minimap)

end

function TrackingCycler:OnEnable()

end

